package com.izenpe.zain.cliente.xades;

import org.apache.axis.encoding.Base64;

import com.izenpe.zain.client.ZainConfig;
import com.izenpe.zain.cliente.util.Constantes;
import com.izenpe.zain.cliente.util.Propiedades;
import com.izenpe.zain.cliente.util.ZainUtil;
import com.safelayer.trustedx.client.smartwrapper.Constants;
import com.safelayer.trustedx.client.smartwrapper.SmartSignRequest;
import com.safelayer.trustedx.client.smartwrapper.SmartSignResponse;

public class GeneracionFirmaXMLDetached {
	// Nombre del fichero a utilizar para la generación de la firma XML.
	private static final String fileName = "Demo.xml";

	public static void main(String[] args) {
		try {
			// Asignación de la configuración de forma programática
			ZainConfig.setCurrent(Propiedades.ZAIN_CONFIG);

			/*
			 * Se crea la petición a través de la URL definida en ZAIN_ENDPOINT.
			 */
			SmartSignRequest smartSignReq = new SmartSignRequest(Propiedades.ZAIN_ENDPOINT);

			// Se establece el perfil de firma XML (XADES) en la petición de
			// Generación de firma.
			smartSignReq.setProfile(Constants.Profile.XADES);
			
			// Se selecciona el tipo de firma en particular.
			smartSignReq.setSignaturePlacement(Constants.SignaturePlacement.DETACHED);

			/*
			 * Se establece el idioma de la petición en español. 2
			 * posibilidades: 1. Español: 'es' 2. Inglés: 'en'
			 */
			smartSignReq.setLanguage("es");

			// Certificado con el que realizar la firma.
			smartSignReq.setKeySubjectName(Propiedades.ZAIN_SIGNER);

			/*
			 * True para obtener la firma en base64 (y evitar problemas con Axis
			 * al serializar y deserializar firmas XML).
			 */
			smartSignReq.setXmlReturnBase64(true);

			// Datos a firmar.
			smartSignReq.setInputXmlBase64(Base64.encode(ZainUtil.readBinaryFile("data/input/" + fileName)));

			// Envío de la petición.
			SmartSignResponse smartSignResp = smartSignReq.send();

			/*
			 * Se comprueba la validez de la respuesta y se escribe la respuesta
			 * de Generación de firma XML en un fichero en disco.
			 */
			if (Constantes.RMAJOR_SUCCESS.equals((smartSignResp.getResultMajor()))
					&& smartSignResp.getResultMinor() == null) {
				String signXMLBase64 = smartSignResp.getSignatureXmlBase64();
				byte[] data = Base64.decode(signXMLBase64);
				String destFilename = "data/output/" + fileName.substring(0, fileName.lastIndexOf("."))
						+ "SignedDetached.xml";
				ZainUtil.writeBinaryFile(destFilename, data);
				System.out.println("La firma se ha realizado con éxito.");
			} else {
				System.out.println("Error en la Generación de Firma:" + smartSignResp.getResultMessage());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}